import React, { PropTypes } from 'react';
import purebem from 'purebem';

import './FoundationErrors.less';


const block = purebem.of('foundation-errors');

const FoundationErrors = React.createClass({

    propTypes: {
        errors: PropTypes.arrayOf(PropTypes.node),
    },

    getDefaultProps() {
        return {
            errors: [],
        };
    },

    renderError(error, index, errors) {
        const singleError = errors.length === 1;
        return (
            <li key={ index } className={ block('error', { singleError }) }>
                { errors }
            </li>
        );
    },

    render() {
        if (this.props.errors.length === 0) {
            return null;
        }

        return (
            <div className={ block() }>
                <ul className={ block('error-list') }>
                    { [].map.call(this.props.errors, this.renderError) }
                </ul>
            </div>
        );
    },

});

export default FoundationErrors;
